<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Base\BaseModel;

class AdministratorgroupaccessModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "administratorgroupaccess";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "administratorgroupaccess";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "groupid", "accessid", "date_updated"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "administratorgroupaccess.id",
        "groupid" => "roles.id",
        "accessid" => "administratormenu.id",
    ];

    /**
     * relation from ' . administratorgroup . ' by ' . groupid
     * join administratorgroup on administratorgroup.id = administratorgroupaccess.groupid
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationGroupid($alias = "roles")
    {
        $this->getQuery()->join("roles as $alias", "$alias.id", "=", "administratorgroupaccess.groupid");
        return $this;
    }

    /**
     * relation from ' . administratormenuacess . ' by ' . accessid
     * join administratormenuacess on administratormenuacess.id = administratorgroupaccess.accessid
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationAccessid($alias = "administratormenu")
    {
        $this->getQuery()->join("administratormenu as $alias", "$alias.id", "=", "administratorgroupaccess.accessid");
        return $this;
    }

    public static function storeFromHO($data)
    {

        $modelExist = (new self())->getQuery()->where("administratorgroupaccess.groupid", "=", $data->groupid)
            ->where("administratorgroupaccess.accessid", "=", $data->accessid)
            ->first();
        if ($modelExist) {
            $model = self::find($modelExist->id);
            $model->groupid = $data->groupid;
            $model->accessid = $data->accessid;
            $model->date_updated = $data->date_updated;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Group Acess - ".$data->groupid." - ".$data->accessid, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->groupid = $data->groupid;
            $model->accessid = $data->accessid;
            $model->date_updated = $data->date_updated;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Group Acess - ".$data->groupid." - ".$data->accessid, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->groupid . " sync", PHP_EOL;
    }

    public static function getMenuAccess()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_group_access";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 6)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Group Acess HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $syncHandler = new \App\Http\Handler\CurlHandler();
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
			if($page == 1) {
                       	     \App\Http\Models\AdministratorgroupaccessModel::truncate();
                       	}
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\AdministratorgroupaccessModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else $fetch = false;
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Group Acess HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Group Acess HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}
